class
	SD_IO_MARKER

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			make_initialized,
			structure_size,
			offset_of,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_next: CE_POINTER [SD_IO_MARKER]
				a_sbuf: CE_POINTER [SD_IO_FILE]
				a_pos: INTEGER_32
			])
		require else
			a_data /= Void
		do
			make
			Current.next := a_data.a_next
			Current.sbuf := a_data.a_sbuf
			Current.pos := a_data.a_pos
		end

feature {ANY} -- fields

	next: CE_POINTER [SD_IO_MARKER] assign set_next
		do
			create {CE_CLASS_POINTER [SD_IO_MARKER]} Result.make_shared (c__next (internal_c_pointer))
		end

	sbuf: CE_POINTER [SD_IO_FILE] assign set_sbuf
		do
			create {CE_CLASS_POINTER [SD_IO_FILE]} Result.make_shared (c__sbuf (internal_c_pointer))
		end

	pos: INTEGER_32 assign set_pos
		do
			Result := c__pos (internal_c_pointer)
		end

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [SD_IO_MARKER])
		do
			c__set_next (internal_c_pointer, a_next.c_pointer)
		end

	set_sbuf (a_sbuf: CE_POINTER [SD_IO_FILE])
		do
			c__set_sbuf (internal_c_pointer, a_sbuf.c_pointer)
		end

	set_pos (a_pos: INTEGER_32)
		do
			c__set_pos (internal_c_pointer, a_pos)
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"libmpz.h%""
		alias
			"return sizeof(struct _IO_marker);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"libmpz.h%""
		alias
			"return __alignof__(struct _IO_marker);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__next (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmpz.h%""
		alias
			"return (EIF_POINTER)((struct _IO_marker *)$a_c_pointer)->_next;"
		end

	c__sbuf (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmpz.h%""
		alias
			"return (EIF_POINTER)((struct _IO_marker *)$a_c_pointer)->_sbuf;"
		end

	c__pos (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"libmpz.h%""
		alias
			"return ((struct _IO_marker *)$a_c_pointer)->_pos;"
		end

	c__set_next (a_c_pointer: POINTER; a_next: POINTER)
		external
			"C inline use %"libmpz.h%""
		alias
			"((struct _IO_marker *)$a_c_pointer)->_next = $a_next;"
		end

	c__set_sbuf (a_c_pointer: POINTER; a_sbuf: POINTER)
		external
			"C inline use %"libmpz.h%""
		alias
			"((struct _IO_marker *)$a_c_pointer)->_sbuf = $a_sbuf;"
		end

	c__set_pos (a_c_pointer: POINTER; a_pos: INTEGER_32)
		external
			"C inline use %"libmpz.h%""
		alias
			"((struct _IO_marker *)$a_c_pointer)->_pos = $a_pos;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"libmpz.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "next") == 0) return offsetof(struct _IO_marker, _next);
				if(strcmp($a_field_name, "sbuf") == 0) return offsetof(struct _IO_marker, _sbuf);
				if(strcmp($a_field_name, "pos") == 0) return offsetof(struct _IO_marker, _pos);
				fprintf(stderr, "struct _IO_marker.%s not found\n", $a_field_name);
				return -1;
			]"
		end

end
