class
	P_AORS_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gmpz_add (a_w, a_u, a_v: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_u: CE_POINTER [PD_MPZ_STRUCT]
			l_v: CE_POINTER [PD_MPZ_STRUCT]
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_wp: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_wsize: INTEGER_32
			l_abs_usize: INTEGER_32
			l_abs_vsize: INTEGER_32
			l_mpz_srcptr_swap_tmp: CE_POINTER [PD_MPZ_STRUCT]
			l_mp_size_t_swap_tmp: INTEGER_32
			l_mp_size_t_swap_tmp_0: INTEGER_32
			l_cy_limb: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_u := a_u
			l_v := a_v
			l_usize := (l_u.item.mp_size).to_integer_32
			l_vsize := (l_v.item.mp_size).to_integer_32
			if l_usize >= 0 then
				l_abs_usize := l_usize
			else
				l_abs_usize := -l_usize
			end
			if l_vsize >= 0 then
				l_abs_vsize := l_vsize
			else
				l_abs_vsize := -l_vsize
			end
			if l_abs_usize < l_abs_vsize then
				from
				until
					(l_break)
				loop
					l_break := False
					l_mpz_srcptr_swap_tmp := l_u
					l_u := l_v
					l_v := l_mpz_srcptr_swap_tmp
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_mp_size_t_swap_tmp := l_usize
					l_usize := l_vsize
					l_vsize := l_mp_size_t_swap_tmp
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_mp_size_t_swap_tmp_0 := l_abs_usize
					l_abs_usize := l_abs_vsize
					l_abs_vsize := l_mp_size_t_swap_tmp_0
					l_break := True
				end
				l_break := False
			end
			l_wsize := l_abs_usize + 1
			if (a_w.item.mp_alloc).to_integer_32 < l_wsize then
				(create {P_REALLOC_STATIC}).gmpz_realloc (a_w, l_wsize).do_nothing
			end
			l_up := l_u.item.mp_d
			l_vp := l_v.item.mp_d
			l_wp := a_w.item.mp_d
			if ((l_usize).bit_xor (l_vsize)) < 0 then
				if l_abs_usize /= l_abs_vsize then
					(create {P_GMP_STATIC}).gmpn_sub (l_wp, l_up, l_abs_usize, l_vp, l_abs_vsize).do_nothing
					l_wsize := l_abs_usize
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							not (not (l_break) and then (l_wsize > 0))
						loop
							l_break := False
							if l_wp[(l_wsize - 1)] /= {NATURAL_32} 0 then
								l_break := True
							end
							if not (l_break) then
								l_wsize := l_wsize - 1
							end
						end
						l_break := False
						l_break := True
					end
					l_break := False
					if l_usize < 0 then
						l_wsize := -l_wsize
					end
				elseif ((create {P_GMP_STATIC}).gmpn_cmp (l_up, l_vp, l_abs_usize)) < 0 then
					(create {P_GMP_STATIC}).gmpn_sub_n (l_wp, l_vp, l_up, l_abs_usize).do_nothing
					l_wsize := l_abs_usize
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							not (not (l_break) and then (l_wsize > 0))
						loop
							l_break := False
							if l_wp[(l_wsize - 1)] /= {NATURAL_32} 0 then
								l_break := True
							end
							if not (l_return or l_break) then
								l_wsize := l_wsize - 1
							end
						end
						l_break := False
						l_break := True
					end
					l_break := False
					if l_usize >= 0 then
						l_wsize := -l_wsize
					end
				else
					(create {P_GMP_STATIC}).gmpn_sub_n (l_wp, l_up, l_vp, l_abs_usize).do_nothing
					l_wsize := l_abs_usize
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							not (not (l_break) and then (l_wsize > 0))
						loop
							l_break := False
							if l_wp[(l_wsize - 1)] /= {NATURAL_32} 0 then
								l_break := True
							end
							if not (l_return or l_break) then
								l_wsize := l_wsize - 1
							end
						end
						l_break := False
						l_break := True
					end
					l_break := False
					if l_usize < 0 then
						l_wsize := -l_wsize
					end
				end
			else
				l_cy_limb := ((create {P_GMP_STATIC}).gmpn_add (l_wp, l_up, l_abs_usize, l_vp, l_abs_vsize))
				l_wp[l_abs_usize] := l_cy_limb
				l_wsize := (l_abs_usize.to_natural_32 + l_cy_limb).to_integer_32
				if l_usize < 0 then
					l_wsize := -l_wsize
				end
			end
			a_w.item.mp_size := l_wsize.to_integer_32
		end

	gmpz_sub (a_w, a_u, a_v: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_u: CE_POINTER [PD_MPZ_STRUCT]
			l_v: CE_POINTER [PD_MPZ_STRUCT]
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_wp: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_wsize: INTEGER_32
			l_abs_usize: INTEGER_32
			l_abs_vsize: INTEGER_32
			l_mpz_srcptr_swap_tmp: CE_POINTER [PD_MPZ_STRUCT]
			l_mp_size_t_swap_tmp: INTEGER_32
			l_mp_size_t_swap_tmp_0: INTEGER_32
			l_cy_limb: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_u := a_u
			l_v := a_v
			l_usize := (l_u.item.mp_size).to_integer_32
			l_vsize := (-l_v.item.mp_size).to_integer_32
			if l_usize >= 0 then
				l_abs_usize := l_usize
			else
				l_abs_usize := -l_usize
			end
			if l_vsize >= 0 then
				l_abs_vsize := l_vsize
			else
				l_abs_vsize := -l_vsize
			end
			if l_abs_usize < l_abs_vsize then
				from
				until
					(l_break)
				loop
					l_break := False
					l_mpz_srcptr_swap_tmp := l_u
					l_u := l_v
					l_v := l_mpz_srcptr_swap_tmp
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_mp_size_t_swap_tmp := l_usize
					l_usize := l_vsize
					l_vsize := l_mp_size_t_swap_tmp
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_mp_size_t_swap_tmp_0 := l_abs_usize
					l_abs_usize := l_abs_vsize
					l_abs_vsize := l_mp_size_t_swap_tmp_0
					l_break := True
				end
				l_break := False
			end
			l_wsize := l_abs_usize + 1
			if (a_w.item.mp_alloc).to_integer_32 < l_wsize then
				(create {P_REALLOC_STATIC}).gmpz_realloc (a_w, l_wsize).do_nothing
			end
			l_up := l_u.item.mp_d
			l_vp := l_v.item.mp_d
			l_wp := a_w.item.mp_d
			if ((l_usize).bit_xor (l_vsize)) < 0 then
				if l_abs_usize /= l_abs_vsize then
					(create {P_GMP_STATIC}).gmpn_sub (l_wp, l_up, l_abs_usize, l_vp, l_abs_vsize).do_nothing
					l_wsize := l_abs_usize
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							not (not (l_break) and then (l_wsize > 0))
						loop
							l_break := False
							if l_wp[(l_wsize - 1)] /= {NATURAL_32} 0 then
								l_break := True
							end
							if not (l_break) then
								l_wsize := l_wsize - 1
							end
						end
						l_break := False
						l_break := True
					end
					l_break := False
					if l_usize < 0 then
						l_wsize := -l_wsize
					end
				elseif ((create {P_GMP_STATIC}).gmpn_cmp (l_up, l_vp, l_abs_usize)) < 0 then
					(create {P_GMP_STATIC}).gmpn_sub_n (l_wp, l_vp, l_up, l_abs_usize).do_nothing
					l_wsize := l_abs_usize
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							not (not (l_break) and then (l_wsize > 0))
						loop
							l_break := False
							if l_wp[(l_wsize - 1)] /= {NATURAL_32} 0 then
								l_break := True
							end
							if not (l_return or l_break) then
								l_wsize := l_wsize - 1
							end
						end
						l_break := False
						l_break := True
					end
					l_break := False
					if l_usize >= 0 then
						l_wsize := -l_wsize
					end
				else
					(create {P_GMP_STATIC}).gmpn_sub_n (l_wp, l_up, l_vp, l_abs_usize).do_nothing
					l_wsize := l_abs_usize
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							not (not (l_break) and then (l_wsize > 0))
						loop
							l_break := False
							if l_wp[(l_wsize - 1)] /= {NATURAL_32} 0 then
								l_break := True
							end
							if not (l_return or l_break) then
								l_wsize := l_wsize - 1
							end
						end
						l_break := False
						l_break := True
					end
					l_break := False
					if l_usize < 0 then
						l_wsize := -l_wsize
					end
				end
			else
				l_cy_limb := ((create {P_GMP_STATIC}).gmpn_add (l_wp, l_up, l_abs_usize, l_vp, l_abs_vsize))
				l_wp[l_abs_usize] := l_cy_limb
				l_wsize := (l_abs_usize.to_natural_32 + l_cy_limb).to_integer_32
				if l_usize < 0 then
					l_wsize := -l_wsize
				end
			end
			a_w.item.mp_size := l_wsize.to_integer_32
		end

end
