class
	P_AORSMUL_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_aorsmul (a_sub: INTEGER_32; a_w, a_x, a_y: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_sub: INTEGER_32
			l_x: CE_POINTER [PD_MPZ_STRUCT]
			l_y: CE_POINTER [PD_MPZ_STRUCT]
			l_xsize: INTEGER_32
			l_ysize: INTEGER_32
			l_tsize: INTEGER_32
			l_wsize: INTEGER_32
			l_wsize_signed: INTEGER_32
			l_wp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_c: NATURAL_32
			l_high: NATURAL_32
			l_tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_mpz_srcptr_swap_tmp: CE_POINTER [PD_MPZ_STRUCT]
			l_mp_size_t_swap_tmp: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp_0: INTEGER_32
			l_tmp_1: INTEGER_32
			l_tmp_2: INTEGER_32
			l_tmp_7: CE_POINTER [ANY]
			l_up: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_up_0: CE_POINTER [NATURAL_32]
			l_usize_0: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l_tmp_marker.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_sub := a_sub
					l_x := a_x
					l_y := a_y
					l_xsize := (l_x.item.mp_size).to_integer_32
					l_ysize := (l_y.item.mp_size).to_integer_32
					if l_xsize = 0 then
						l_return := True
					elseif l_ysize = 0 then
						l_return := True
					end
					if not l_return then
						if l_ysize >= 0 then
							l_tmp := l_ysize
						else
							l_tmp := -l_ysize
						end
						if l_xsize >= 0 then
							l_tmp_0 := l_xsize
						else
							l_tmp_0 := -l_xsize
						end
						if l_tmp > l_tmp_0 then
							from
							until
								(l_break)
							loop
								l_break := False
								l_mpz_srcptr_swap_tmp := l_x
								l_x := l_y
								l_y := l_mpz_srcptr_swap_tmp
								l_break := True
							end
							l_break := False
							from
							until
								(l_break)
							loop
								l_break := False
								l_mp_size_t_swap_tmp := l_xsize
								l_xsize := l_ysize
								l_ysize := l_mp_size_t_swap_tmp
								l_break := True
							end
							l_break := False
						end
						l_sub := (l_sub).bit_xor (l_ysize)
						if l_ysize >= 0 then
							l_ysize := l_ysize
						else
							l_ysize := -l_ysize
						end
						if l_ysize = 1 then
							(create {P_AORSMUL_I_STATIC}).gmpz_aorsmul_1 (l_sub, a_w, l_x, l_y.item.mp_d[0])
							l_return := True
						end
					end
					if not l_return then
						l_sub := (l_sub).bit_xor (l_xsize)
						if l_xsize >= 0 then
							l_xsize := l_xsize
						else
							l_xsize := -l_xsize
						end
						l_wsize_signed := (a_w.item.mp_size).to_integer_32
						l_sub := (l_sub).bit_xor (l_wsize_signed)
						if l_wsize_signed >= 0 then
							l_wsize := l_wsize_signed
						else
							l_wsize := -l_wsize_signed
						end
						l_tsize := l_xsize + l_ysize
						if l_wsize > l_tsize then
							l_tmp_2 := l_wsize
						else
							l_tmp_2 := l_tsize
						end
						if (builtin_expect ((l_tmp_2 + 1 > (a_w.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
							if l_wsize > l_tsize then
								l_tmp_1 := l_wsize
							else
								l_tmp_1 := l_tsize
							end
							(create {P_REALLOC_STATIC}).gmpz_realloc (a_w, l_tmp_1 + 1).do_nothing
						end
						l_wp := a_w.item.mp_d
						if l_wsize_signed = 0 then
							l_high := (create {P_GMP_STATIC}).gmpn_mul (l_wp, l_x.item.mp_d, l_xsize, l_y.item.mp_d, l_ysize)
							l_tsize := l_tsize - (l_high = {NATURAL_32} 0).to_integer
							if l_sub >= 0 then
								a_w.item.mp_size := l_tsize.to_integer_32
							else
								a_w.item.mp_size := (-l_tsize).to_integer_32
							end
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						l_tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
						if (builtin_expect ((l_tsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp_7 := (l_aaf.new ((l_tsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp_7 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, (l_tsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_tp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_7)
						l_high := (create {P_GMP_STATIC}).gmpn_mul (l_tp, l_x.item.mp_d, l_xsize, l_y.item.mp_d, l_ysize)
						l_tsize := l_tsize - (l_high = {NATURAL_32} 0).to_integer
						if not (l_sub >= 0) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_up := l_wp
						l_usize := l_wsize
						if l_usize < l_tsize then
							l_up := l_tp
							l_usize := l_tsize
							l_tp := l_wp
							l_tsize := l_wsize
							l_wsize := l_usize
						end
						l_c := (create {P_GMP_STATIC}).gmpn_add (l_wp, l_up, l_usize, l_tp, l_tsize)
						l_wp[l_wsize] := l_c
						l_wsize := l_wsize + (l_c /= {NATURAL_32} 0).to_integer
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 4 then -- else:
						l_up_0 := l_wp
						l_usize_0 := l_wsize
						if not (l_usize_0 < l_tsize) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 7 then -- else:
						if l_usize_0 /= l_tsize then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if not (((create {P_GMP_STATIC}).gmpn_cmp (l_up_0, l_tp, l_usize_0)) < 0) then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L:
						l_up_0 := l_tp
						l_usize_0 := l_tsize
						l_tp := l_wp
						l_tsize := l_wsize
						l_wsize := l_usize_0
						l_wsize_signed := -l_wsize_signed
				when 10 then -- if done | if done;
						(create {P_GMP_STATIC}).gmpn_sub (l_wp, l_up_0, l_usize_0, l_tp, l_tsize).do_nothing
						l_wsize := l_usize_0
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								not (not (l_break) and then (l_wsize > 0))
							loop
								l_break := False
								if l_wp[(l_wsize - 1)] /= {NATURAL_32} 0 then
									l_break := True
								end
								if not (l_break) then
									l_wsize := l_wsize - 1
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
				when 11 then -- if done
						if l_wsize_signed >= 0 then
							a_w.item.mp_size := l_wsize.to_integer_32
						else
							a_w.item.mp_size := (-l_wsize).to_integer_32
						end
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect ((not (l_tmp_marker.item).is_void).to_integer, 0)).to_boolean then
								(create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_free (l_tmp_marker.item)
							end
							l_break := True
						end
						l_break := False
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpz_addmul (a_w, a_u, a_v: CE_POINTER [PD_MPZ_STRUCT])
		do
			gmpz_aorsmul ((0).to_integer_32, a_w, a_u, a_v)
		end

	gmpz_submul (a_w, a_u, a_v: CE_POINTER [PD_MPZ_STRUCT])
		do
			gmpz_aorsmul ((-1).to_integer_32, a_w, a_u, a_v)
		end

end
