class
	P_BIN_UI_STATIC

inherit
	CE_UTILITIES
	LIBMPZ_ASSEMBLER

feature {ANY} -- public routines

	gmpz_bin_ui (a_r, a_n: CE_POINTER [PD_MPZ_STRUCT]; a_k: NATURAL_32)
		local
			l_k: NATURAL_32
			l_ni: CE_ARRAY [PD_MPZ_STRUCT]
			l_i: CE_ARRAY [NATURAL_32]
			l_nacc: CE_ARRAY [PD_MPZ_STRUCT]
			l_kacc: CE_ARRAY [NATURAL_32]
			l_negate: INTEGER_32
			l_tmp_1: INTEGER_32
			l_tmp_2: NATURAL_32
			l_k1: CE_ARRAY [NATURAL_32]
			l_k0: CE_ARRAY [NATURAL_32]
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_ni.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_i.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_nacc.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_kacc.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_k1.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_k0.make (<<1>>)

			l_k := a_k
			if a_n.item.mp_size < 0 then
				l_tmp_1 := -1
			else
				l_tmp_1 := (a_n.item.mp_size > 0).to_integer
			end
			if l_tmp_1 < 0 then
				(create {P_INIT_STATIC}).gmpz_init (l_ni);
				(create {P_NEG_STATIC}).gmpz_neg (l_ni, a_n);
				(create {P_AORS_UI_STATIC}).gmpz_sub_ui (l_ni, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_ni), {NATURAL_32} 1)
				l_negate := ((l_k).bit_and ({NATURAL_32} 1)).to_integer_32
			else
				if ((create {P_CMP_UI_STATIC}).gmpz_cmp_ui (a_n, l_k)) < 0 then
					(create {P_SET_UI_STATIC}).gmpz_set_ui (a_r, {NATURAL_32} 0)
					l_return := True
				end
				if not l_return then
					(create {P_INIT_STATIC}).gmpz_init (l_ni);
					(create {P_AORS_UI_STATIC}).gmpz_sub_ui (l_ni, a_n, l_k)
					l_negate := (0).to_integer_32
				end
			end
			if not l_return then
				(create {P_SET_UI_STATIC}).gmpz_set_ui (a_r, {NATURAL_32} 1)
				if ((create {P_CMP_UI_STATIC}).gmpz_cmp_ui (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_ni), l_k)) < 0 then
					l_tmp_2 := l_k
					l_k := (create {P_GMP_STATIC}).gmpz_get_ui (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_ni));
					(create {P_SET_UI_STATIC}).gmpz_set_ui (l_ni, l_tmp_2)
				end
				l_kacc.item := (1).to_natural_32;
				(create {P_ISET_UI_STATIC}).gmpz_init_set_ui (l_nacc, {NATURAL_32} 1)
				l_i.item := (1).to_natural_32
				from
				until
					not (not (l_return) and then (l_i.item <= l_k))
				loop
					(create {P_AORS_UI_STATIC}).gmpz_add_ui (l_ni, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_ni), {NATURAL_32} 1);
					(create {P_MUL_STATIC}).gmpz_mul (l_nacc, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_nacc), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_ni))
					asm3 (l_k0, l_k1, l_kacc, l_i)
					l_k0.item := l_k0.item
					if l_k1.item /= {NATURAL_32} 0 then
						(create {P_MUL_STATIC}).gmpz_mul (a_r, a_r, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_nacc));
						(create {P_SET_UI_STATIC}).gmpz_set_ui (l_nacc, {NATURAL_32} 1)
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_IMPL_STATIC}).gmpn_divexact_1 (a_r.item.mp_d, a_r.item.mp_d, (a_r.item.mp_size).to_integer_32, l_kacc.item)
								l_break := True
							end
							l_break := False
							a_r.item.mp_size := a_r.item.mp_size - (a_r.item.mp_d[(a_r.item.mp_size - 1)] = {NATURAL_32} 0).to_integer
							l_break := True
						end
						l_break := False
						l_kacc.item := l_i.item
					else
						l_kacc.item := l_k0.item
					end
					l_i.item := l_i.item + 1
				end
				(create {P_MUL_STATIC}).gmpz_mul (a_r, a_r, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_nacc))
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_GMP_IMPL_STATIC}).gmpn_divexact_1 (a_r.item.mp_d, a_r.item.mp_d, (a_r.item.mp_size).to_integer_32, l_kacc.item)
						l_break := True
					end
					l_break := False
					a_r.item.mp_size := a_r.item.mp_size - (a_r.item.mp_d[(a_r.item.mp_size - 1)] = {NATURAL_32} 0).to_integer
					l_break := True
				end
				l_break := False
				a_r.item.mp_size := ((((a_r.item.mp_size).to_integer_32).bit_xor (-l_negate)) + l_negate).to_integer_32;
				(create {P_CLEAR_STATIC}).gmpz_clear (l_nacc);
				(create {P_CLEAR_STATIC}).gmpz_clear (l_ni)
			end
		end

end
