class
	P_CDIV_R_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_cdiv_r (a_rem, a_dividend, a_divisor: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_divisor: CE_POINTER [PD_MPZ_STRUCT]
			l_divisor_size: INTEGER_32
			l_temp_divisor: CE_ARRAY [PD_MPZ_STRUCT]
			l_tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_x: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp_1: INTEGER_32
			l_tmp_3: INTEGER_32
			l_tmp_5: CE_POINTER [ANY]
			l_tmp_6: INTEGER_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_temp_divisor.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l_tmp_marker.make (<<1>>)

			l_divisor := a_divisor
			l_divisor_size := (l_divisor.item.mp_size).to_integer_32
			l_tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			if a_rem.is_equal (l_divisor) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_x := l_temp_divisor
					if l_divisor_size >= 0 then
						l_x.item.mp_alloc := l_divisor_size.to_integer_32
					else
						l_x.item.mp_alloc := (-l_divisor_size).to_integer_32
					end
					if l_divisor_size >= 0 then
						l_tmp_6 := l_divisor_size
					else
						l_tmp_6 := -l_divisor_size
					end
					if (builtin_expect ((l_tmp_6.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						if l_divisor_size >= 0 then
							l_tmp_1 := l_divisor_size
						else
							l_tmp_1 := -l_divisor_size
						end
						l_tmp_5 := (l_aaf.new ((l_tmp_1.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						if l_divisor_size >= 0 then
							l_tmp_3 := l_divisor_size
						else
							l_tmp_3 := -l_divisor_size
						end
						l_tmp_5 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, (l_tmp_3.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l_x.item.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_5)
					l_break := True
				end
				l_break := False;
				(create {P_SET_STATIC}).gmpz_set (l_temp_divisor, l_divisor)
				l_divisor := create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_temp_divisor)
			end
			(create {P_TDIV_R_STATIC}).gmpz_tdiv_r (a_rem, a_dividend, l_divisor)
			if ((l_divisor_size).bit_xor ((a_dividend.item.mp_size).to_integer_32)) >= 0 then
				if a_rem.item.mp_size /= 0 then
					(create {P_AORS_STATIC}).gmpz_sub (a_rem, a_rem, l_divisor)
				end
			end
			from
			until
				(l_break)
			loop
				l_break := False
				if (builtin_expect ((not (l_tmp_marker.item).is_void).to_integer, 0)).to_boolean then
					(create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_free (l_tmp_marker.item)
				end
				l_break := True
			end
			l_break := False
		end

end
