class
	P_CDIV_R_UI_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gmpz_cdiv_r_ui (a_rem, a_dividend: CE_POINTER [PD_MPZ_STRUCT]; a_divisor: NATURAL_32): NATURAL_32
		local
			l_ns: INTEGER_32
			l_nn: INTEGER_32
			l_np: CE_POINTER [NATURAL_32]
			l_rl: NATURAL_32
			l_return: BOOLEAN
		do
			if a_divisor = {NATURAL_32} 0 then
				(create {P_GMP_IMPL_STATIC}).gmp_divide_by_zero
			end
			l_ns := (a_dividend.item.mp_size).to_integer_32
			if l_ns = 0 then
				a_rem.item.mp_size := 0
				Result := {NATURAL_32} 0
				l_return := True
			end
			if not l_return then
				if l_ns >= 0 then
					l_nn := l_ns
				else
					l_nn := -l_ns
				end
				l_np := a_dividend.item.mp_d
				l_rl := (create {P_GMP_STATIC}).gmpn_mod_1 (l_np, l_nn, a_divisor)
				if l_rl = {NATURAL_32} 0 then
					a_rem.item.mp_size := 0
				else
					if l_ns >= 0 then
						l_rl := a_divisor - l_rl
					end
					a_rem.item.mp_d[0] := l_rl
					a_rem.item.mp_size := -1
				end
				Result := l_rl
			end
		end

end
