class
	P_CMP_D_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_cmp_d (a_z: CE_POINTER [PD_MPZ_STRUCT]; a_d: REAL_64): INTEGER_32
		local
			l_d: REAL_64
			l_darray: CE_ARRAY [NATURAL_32]
			l_zlimb: NATURAL_32
			l_dlimb: NATURAL_32
			l_zp: CE_POINTER [NATURAL_32]
			l_zsize: INTEGER_32
			l_dexp: INTEGER_32
			l_ret: INTEGER_32
			l_u: PD_IEEE_DOUBLE_EXTRACT
			l_tmp_0: INTEGER_32
			l_tmp_1: INTEGER_32
			l_tmp_2: INTEGER_32
			l_tmp_3: INTEGER_32
			l_tmp_4: INTEGER_32
			l_tmp_5: INTEGER_32
			l_tmp_6: INTEGER_32
			l_i: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_32_ARRAY} l_darray.make (<<3>>)
			create l_u.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_d := a_d
				when 1 then -- loop condition:
					if (l_break) then
						l_pos := -1 + 4 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						l_u.d := l_d
						l_u.update_class_fields -- synchronize union
						if (builtin_expect ((l_u.s.exp = {NATURAL_32} 2_047).to_integer, 0)).to_boolean then
							if l_u.s.manl = {NATURAL_32} 0 then
								if l_u.s.manh = {NATURAL_32} 0 then
									l_pos := -1 + 5 -- goto z_zero
								else
									(create {P_GMP_IMPL_STATIC}).gmp_invalid_operation
								end
							else
								(create {P_GMP_IMPL_STATIC}).gmp_invalid_operation
							end
						end
				when 3 then
						l_break := True
						l_pos := -1 + 1 -- back to loop condition
				when 4 then -- loop done
					l_break := False
					l_zsize := (a_z.item.mp_size).to_integer_32
					if l_d = 0.0 then
						Result := l_zsize.to_integer_32
						l_return := True
					end
					if not (not l_return and then (l_zsize = 0)) then
						l_pos := -1 + 6 -- skip if block
					end
				when 5 then -- if: | z_zero:
						if l_d < 0.0 then
							l_tmp_0 := 1
						else
							l_tmp_0 := -1
						end
						Result := l_tmp_0
						l_return := True
				when 6 then -- if done
					if not l_return then
						if l_zsize >= 0 then
							if l_d < 0.0 then
								Result := 1
								l_return := True
							end
							if not l_return then
								l_ret := 1
							end
						else
							if l_d >= 0.0 then
								Result := (-1)
								l_return := True
							end
							if not l_return then
								l_ret := -1
								l_d := -l_d
								l_zsize := -l_zsize
							end
						end
					end
					if not l_return and then (l_d < 1.0) then
						Result := l_ret
						l_return := True
					end
					if not l_return then
						l_dexp := (create {P_GMP_IMPL_STATIC}).gmp_extract_double (l_darray, l_d)
						if l_zsize /= l_dexp.to_integer_32 then
							if l_zsize >= l_dexp.to_integer_32 then
								l_tmp_1 := l_ret
							else
								l_tmp_1 := -l_ret
							end
							Result := l_tmp_1
							l_return := True
						end
					end
					if not l_return then
						l_zp := a_z.item.mp_d
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_zlimb := l_zp[(l_zsize - 1)]
							l_dlimb := l_darray[2]
							if l_zlimb /= l_dlimb then
								if l_zlimb >= l_dlimb then
									l_tmp_2 := l_ret
								else
									l_tmp_2 := -l_ret
								end
								Result := l_tmp_2
								l_return := True
							end
							if not l_return then
								l_break := True
							end
						end
					end
					if not l_return then
						l_break := False
						if l_zsize = 1 then
							if ((l_darray[0]).bit_or (l_darray[1])) /= {NATURAL_32} 0 then
								l_tmp_3 := -l_ret
							else
								l_tmp_3 := 0
							end
							Result := l_tmp_3
							l_return := True
						end
					end
					if not l_return then
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_zlimb := l_zp[(l_zsize - 2)]
							l_dlimb := l_darray[1]
							if l_zlimb /= l_dlimb then
								if l_zlimb >= l_dlimb then
									l_tmp_4 := l_ret
								else
									l_tmp_4 := -l_ret
								end
								Result := l_tmp_4
								l_return := True
							end
							if not l_return then
								l_break := True
							end
						end
					end
					if not l_return then
						l_break := False
						if l_zsize = 2 then
							if l_darray[0] /= {NATURAL_32} 0 then
								l_tmp_5 := -l_ret
							else
								l_tmp_5 := 0
							end
							Result := l_tmp_5
							l_return := True
						end
					end
					if not l_return then
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_zlimb := l_zp[(l_zsize - 3)]
							l_dlimb := l_darray[0]
							if l_zlimb /= l_dlimb then
								if l_zlimb >= l_dlimb then
									l_tmp_6 := l_ret
								else
									l_tmp_6 := -l_ret
								end
								Result := l_tmp_6
								l_return := True
							end
							if not l_return then
								l_break := True
							end
						end
					end
					if not l_return then
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_i := (l_zsize - 3) - 1
							from
							until
								not (not (l_return) and then (l_i >= 0))
							loop
								if l_zp[l_i] /= {NATURAL_32} 0 then
									Result := l_ret
									l_return := True
								end
								if not l_return then
									l_i := l_i - 1
								end
							end
							if not l_return then
								Result := 0
								l_return := True
							end
							if not l_return then
								l_break := True
							end
						end
					end
					if not l_return then
						l_break := False
						Result := 0
					end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
