class
	P_DIVEXACT_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_divexact (a_quot, a_num, a_den: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_qp: CE_POINTER [NATURAL_32]
			l_qn: INTEGER_32
			l_np: CE_POINTER [NATURAL_32]
			l_dp: CE_POINTER [NATURAL_32]
			l_nn: INTEGER_32
			l_dn: INTEGER_32
			l_tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp_3: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l_tmp_marker.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_num.item.mp_size >= 0 then
						l_nn := (a_num.item.mp_size).to_integer_32
					else
						l_nn := (-a_num.item.mp_size).to_integer_32
					end
					if a_den.item.mp_size >= 0 then
						l_dn := (a_den.item.mp_size).to_integer_32
					else
						l_dn := (-a_den.item.mp_size).to_integer_32
					end
					l_qn := (l_nn - l_dn) + 1
					if (builtin_expect ((l_qn > (a_quot.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
						(create {P_REALLOC_STATIC}).gmpz_realloc (a_quot, l_qn).do_nothing
					end
					if l_nn < l_dn then
						a_quot.item.mp_size := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						l_tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
						l_qp := a_quot.item.mp_d
						if not (a_quot.is_equal (a_num)) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not (a_quot.is_equal (a_den)) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if (builtin_expect ((l_qn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp_3 := (l_aaf.new ((l_qn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp_3 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, (l_qn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_qp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_3)
				when 6 then -- if done
						l_np := a_num.item.mp_d
						l_dp := a_den.item.mp_d;
						(create {P_GMP_IMPL_STATIC}).gmpn_divexact (l_qp, l_np, l_nn, l_dp, l_dn)
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								not (not (l_break) and then (l_qn > 0))
							loop
								l_break := False
								if l_qp[(l_qn - 1)] /= {NATURAL_32} 0 then
									l_break := True
								end
								if not (l_break) then
									l_qn := l_qn - 1
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						if ((a_num.item.mp_size).bit_xor (a_den.item.mp_size)) >= 0 then
							a_quot.item.mp_size := l_qn.to_integer_32
						else
							a_quot.item.mp_size := (-l_qn).to_integer_32
						end
						if not l_qp.is_equal (a_quot.item.mp_d) then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (a_quot.item.mp_d, l_qp, l_qn)
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
						end
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect ((not (l_tmp_marker.item).is_void).to_integer, 0)).to_boolean then
								(create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_free (l_tmp_marker.item)
							end
							l_break := True
						end
						l_break := False
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
