class
	P_EXPORT_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC
	LIBMPZ_ASSEMBLER

feature {ANY} -- public routines

	gmpz_export (a_data: CE_POINTER [ANY]; a_countp: CE_POINTER [NATURAL_32]; a_order: INTEGER_32; a_size: NATURAL_32; a_endian: INTEGER_32; a_nail: NATURAL_32; a_z: CE_POINTER [PD_MPZ_STRUCT]): CE_POINTER [ANY]
		local
			l_data: CE_POINTER [ANY]
			l_countp: CE_POINTER [NATURAL_32]
			l_endian: INTEGER_32
			l_zsize: INTEGER_32
			l_zp: CE_POINTER [NATURAL_32]
			l_count: NATURAL_32
			l_dummy: CE_ARRAY [NATURAL_32]
			l_numb: NATURAL_32
			l_align: NATURAL_32
			l_cnt: INTEGER_32
			l_totbits: NATURAL_32
			l_dst: CE_POINTER [NATURAL_32]
			l_size: INTEGER_32
			l_src: CE_POINTER [NATURAL_32]
			l_i: INTEGER_32
			l_dst_0: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_src_0: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_size_0: INTEGER_32
			l_i_0: INTEGER_32
			l_dst_1: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_size_1: INTEGER_32
			l_src_1: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_i_1: INTEGER_32
			l_limb: NATURAL_32
			l_wbitsmask: NATURAL_32
			l_i2: NATURAL_32
			l_numb_0: NATURAL_32
			l_j: INTEGER_32
			l_wbytes: INTEGER_32
			l_woffset: INTEGER_32
			l_dp: CE_POINTER [NATURAL_8]
			l_lbits: INTEGER_32
			l_wbits: INTEGER_32
			l_zend: CE_POINTER [NATURAL_32]
			l_tmp: NATURAL_32
			l_tmp_0: NATURAL_32
			l_tmp_1: NATURAL_32
			l_tmp_2: NATURAL_32
			l_newlimb: NATURAL_32
			l_tmp_3: CE_POINTER [NATURAL_32]
			l_newlimb_0: NATURAL_32
			l_tmp_4: CE_POINTER [NATURAL_32]
			l_return, l_break: BOOLEAN
		do
			create {CE_NATURAL_32_ARRAY} l_dummy.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_dst_0.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_src_0.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_dst_1.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_src_1.make (<<1>>)

			l_data := a_data
			l_countp := a_countp
			l_endian := a_endian
			if l_countp.is_void then
				l_countp := l_dummy
			end
			l_zsize := (a_z.item.mp_size).to_integer_32
			if l_zsize = 0 then
				l_countp.item := (0).to_natural_32
				Result := l_data
				l_return := True
			end
			if not l_return then
				if l_zsize >= 0 then
					l_zsize := l_zsize
				else
					l_zsize := -l_zsize
				end
				l_zp := a_z.item.mp_d
				l_numb := ({NATURAL_32} 8 * a_size - a_nail).to_natural_32
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						l_cnt := builtin_clzl (l_zp[(l_zsize - 1)])
						l_break := True
					end
					l_break := False
					l_totbits := (l_zsize * 32 - l_cnt.to_integer_32).to_natural_32
					l_count := (((l_totbits + l_numb) - {NATURAL_32} 1) // l_numb).to_natural_32
					l_break := True
				end
				l_break := False
				l_countp.item := l_count
				if l_data.is_void then
					l_data := create {CE_VOID_POINTER}.make_cast ((create {P_GMP_IMPL_STATIC}).gmp_allocate_func.pointer_item ([l_count * a_size]))
				end
				if l_endian = 0 then
					l_endian := -1
				end
				l_align := ((create {CE_INTEGER_8_POINTER}.make_cast (l_data)).distance ((create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)))).to_natural_32 \\ {PLATFORM}.Natural_32_bytes.to_natural_32
				if a_nail = {NATURAL_32} 0 then
					if a_size = {PLATFORM}.Natural_32_bytes.to_natural_32 then
						if l_align = {NATURAL_32} 0 then
							if a_order = -1 then
								if l_endian = -1 then
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										from
										until
											(l_return or l_break)
										loop
											l_break := False;
											(create {P_GMP_STATIC}).gmpn_copyi (create {CE_NATURAL_32_POINTER}.make_cast (l_data), l_zp, l_count.to_integer_32)
											l_break := True
										end
										l_break := False
										l_break := True
									end
									l_break := False
									Result := l_data
									l_return := True
								end
							end
							if not l_return and then (a_order = 1) then
								if l_endian = -1 then
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										l_dst := create {CE_NATURAL_32_POINTER}.make_cast (l_data)
										l_size := l_count.to_integer_32
										l_src := (l_zp + l_size) - 1
										l_i := (0).to_integer_32
										from
										until
											not (l_i < l_size)
										loop
											l_dst.item := l_src.item
											l_dst := l_dst + 1
											l_src := l_src - 1
											l_i := l_i + 1
										end
										l_break := True
									end
									l_break := False
									Result := l_data
									l_return := True
								end
							end
							if not l_return and then (a_order = -1) then
								if l_endian = 1 then
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										l_dst_0.item := create {CE_NATURAL_32_POINTER}.make_cast (l_data)
										l_src_0.item := l_zp
										l_size_0 := l_count.to_integer_32
										l_i_0 := (0).to_integer_32
										from
										until
											not (not (l_return) and then (l_i_0 < l_size_0))
										loop
											from
											until
												(l_break)
											loop
												l_break := False
												asm8 (l_dst_0, l_src_0)
												l_break := True
											end
											l_break := False
											l_dst_0.item := l_dst_0.item + 1
											l_src_0.item := l_src_0.item + 1
											l_i_0 := l_i_0 + 1
										end
										l_break := True
									end
									l_break := False
									Result := l_data
									l_return := True
								end
							end
							if not l_return and then (a_order = 1) then
								if l_endian = 1 then
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										l_dst_1.item := create {CE_NATURAL_32_POINTER}.make_cast (l_data)
										l_size_1 := l_count.to_integer_32
										l_src_1.item := (l_zp + l_size_1) - 1
										l_i_1 := (0).to_integer_32
										from
										until
											not (not (l_return) and then (l_i_1 < l_size_1))
										loop
											from
											until
												(l_break)
											loop
												l_break := False
												asm9 (l_dst_1, l_src_1)
												l_break := True
											end
											l_break := False
											l_dst_1.item := l_dst_1.item + 1
											l_src_1.item := l_src_1.item - 1
											l_i_1 := l_i_1 + 1
										end
										l_break := True
									end
									l_break := False
									Result := l_data
									l_return := True
								end
							end
						end
					end
				end
			end
			if not l_return then
				l_numb_0 := a_size * {NATURAL_32} 8 - a_nail
				l_wbytes := (l_numb_0 // {NATURAL_32} 8).to_integer_32
				l_wbits := (l_numb_0 \\ {NATURAL_32} 8).to_integer_32
				l_wbitsmask := (({NATURAL_32} 1).bit_shift_left (l_wbits)) - {NATURAL_32} 1
				if l_endian >= 0 then
					l_tmp := a_size.to_natural_32
				else
					l_tmp := (-a_size.to_integer_32).to_natural_32
				end
				if a_order < 0 then
					l_tmp_0 := a_size.to_natural_32
				else
					l_tmp_0 := (-a_size.to_integer_32).to_natural_32
				end
				l_woffset := (l_tmp + l_tmp_0).to_integer_32
				if a_order >= 0 then
					l_tmp_1 := (l_count - {NATURAL_32} 1) * a_size
				else
					l_tmp_1 := (0).to_natural_32
				end
				if l_endian >= 0 then
					l_tmp_2 := a_size - {NATURAL_32} 1
				else
					l_tmp_2 := (0).to_natural_32
				end
				l_dp := (create {CE_NATURAL_8_POINTER}.make_cast (l_data) + l_tmp_1.to_integer_32) + l_tmp_2.to_integer_32
				l_zend := l_zp + l_zsize
				l_lbits := 0
				l_limb := (0).to_natural_32
				l_i2 := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i2 < l_count))
				loop
					l_j := (0).to_integer_32
					from
					until
						not (not (l_return) and then (l_j < l_wbytes))
					loop
						from
						until
							(l_break)
						loop
							l_break := False
							if l_lbits >= 8 then
								l_dp.item := l_limb.to_natural_8
								l_limb := (l_limb).bit_shift_right ((8))
								l_lbits := l_lbits - (8)
							else
								if l_zp.is_equal (l_zend) then
									l_newlimb := (0).to_natural_32
								else
									l_tmp_3 := l_zp
									l_zp := l_zp + 1
									l_newlimb := l_tmp_3.item
								end
								l_dp.item := ((l_limb).bit_or (((l_newlimb).bit_shift_left (l_lbits)))).to_natural_8
								l_limb := (l_newlimb).bit_shift_right ((8 - l_lbits))
								l_lbits := l_lbits + (24)
							end
							l_break := True
						end
						l_break := False
						l_dp := l_dp - l_endian
						l_j := l_j + 1
					end
					if l_wbits /= 0 then
						from
						until
							(l_break)
						loop
							l_break := False
							if l_lbits >= l_wbits then
								l_dp.item := ((l_limb).bit_and (l_wbitsmask)).to_natural_8
								l_limb := (l_limb).bit_shift_right (l_wbits)
								l_lbits := l_lbits - l_wbits
							else
								if l_zp.is_equal (l_zend) then
									l_newlimb_0 := (0).to_natural_32
								else
									l_tmp_4 := l_zp
									l_zp := l_zp + 1
									l_newlimb_0 := l_tmp_4.item
								end
								l_dp.item := ((((l_limb).bit_or (((l_newlimb_0).bit_shift_left (l_lbits))))).bit_and (l_wbitsmask)).to_natural_8
								l_limb := (l_newlimb_0).bit_shift_right ((l_wbits - l_lbits))
								l_lbits := l_lbits + (32 - l_wbits)
							end
							l_break := True
						end
						l_break := False
						l_dp := l_dp - l_endian
						l_j := l_j + 1
					end
					from
					until
						not (l_j.to_natural_32 < a_size.to_natural_32)
					loop
						l_dp.item := (('%/0/').code).to_natural_8
						l_dp := l_dp - l_endian
						l_j := l_j + 1
					end
					l_dp := l_dp + l_woffset
					l_i2 := l_i2 + 1
				end
				Result := l_data
			end
		end

end
