class
	P_GET_D_2EXP_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_get_d_2exp (a_exp2: CE_POINTER [INTEGER_32]; a_src: CE_POINTER [PD_MPZ_STRUCT]): REAL_64
		local
			l_size: INTEGER_32
			l_abs_size: INTEGER_32
			l_ptr: CE_POINTER [NATURAL_32]
			l_cnt: INTEGER_32
			l_exp: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_size := (a_src.item.mp_size).to_integer_32
			if (builtin_expect ((l_size = 0).to_integer, 0)).to_boolean then
				a_exp2.item := 0
				Result := (0.0)
				l_return := True
			end
			if not l_return then
				l_ptr := a_src.item.mp_d
				if l_size >= 0 then
					l_abs_size := l_size
				else
					l_abs_size := -l_size
				end
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_cnt := builtin_clzl (l_ptr[(l_abs_size - 1)])
					l_break := True
				end
				l_break := False
				l_exp := l_abs_size * 32 - l_cnt.to_integer_32
				a_exp2.item := l_exp
				Result := ((create {P_GMP_IMPL_STATIC}).gmpn_get_d (l_ptr, l_abs_size, l_size, -l_exp))
			end
		end

end
