class
	P_INVERT_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_invert (a_inverse, a_x, a_n: CE_POINTER [PD_MPZ_STRUCT]): INTEGER_32
		local
			l_gcd: CE_ARRAY [PD_MPZ_STRUCT]
			l_tmp: CE_ARRAY [PD_MPZ_STRUCT]
			l_xsize: INTEGER_32
			l_nsize: INTEGER_32
			l_size: INTEGER_32
			l_tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp_0: INTEGER_32
			l_x: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp_4: CE_POINTER [ANY]
			l_x_0: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp_9: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_gcd.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_tmp.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l_tmp_marker.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_xsize := (a_x.item.mp_size).to_integer_32
					l_nsize := (a_n.item.mp_size).to_integer_32
					if l_xsize >= 0 then
						l_xsize := l_xsize
					else
						l_xsize := -l_xsize
					end
					if l_nsize >= 0 then
						l_nsize := l_nsize
					else
						l_nsize := -l_nsize
					end
					if l_xsize > l_nsize then
						l_tmp_0 := l_xsize
					else
						l_tmp_0 := l_nsize
					end
					l_size := l_tmp_0 + 1
					if l_xsize = 0 then
						Result := 0
						l_return := True
					elseif l_nsize = 1 then
						if a_n.item.mp_d[0] = {NATURAL_32} 1 then
							Result := 0
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_x := l_gcd
							l_x.item.mp_alloc := l_size.to_integer_32
							if (builtin_expect ((l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp_4 := (l_aaf.new ((l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp_4 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, (l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_x.item.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_4)
							l_break := True
						end
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_x_0 := l_tmp
							l_x_0.item.mp_alloc := l_size.to_integer_32
							if (builtin_expect ((l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp_9 := (l_aaf.new ((l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp_9 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, (l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_x_0.item.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_9)
							l_break := True
						end
						l_break := False;
						(create {P_GCDEXT_STATIC}).gmpz_gcdext (l_gcd, l_tmp, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (default_pointer), a_x, a_n)
						if l_gcd[0].mp_size = 1 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if l_gcd[0].mp_d[0] = {NATURAL_32} 1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect ((not (l_tmp_marker.item).is_void).to_integer, 0)).to_boolean then
								(create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_free (l_tmp_marker.item)
							end
							l_break := True
						end
						l_break := False
						Result := 0
						l_return := True
				when 6 then -- if done | if done
					if not l_return then
						if l_tmp[0].mp_size < 0 then
							if a_n.item.mp_size < 0 then
								(create {P_AORS_STATIC}).gmpz_sub (a_inverse, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp), a_n)
							else
								(create {P_AORS_STATIC}).gmpz_add (a_inverse, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp), a_n)
							end
						else
							(create {P_SET_STATIC}).gmpz_set (a_inverse, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp))
						end
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect ((not (l_tmp_marker.item).is_void).to_integer, 0)).to_boolean then
								(create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_free (l_tmp_marker.item)
							end
							l_break := True
						end
						l_break := False
						Result := 1
					end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
