class
	P_KRONUZ_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_ui_kronecker (a_a: NATURAL_32; a_b: CE_POINTER [PD_MPZ_STRUCT]): INTEGER_32
		local
			l_a: NATURAL_32
			l_b_ptr: CE_POINTER [NATURAL_32]
			l_b_low: NATURAL_32
			l_b_abs_size: INTEGER_32
			l_b_rem: NATURAL_32
			l_twos: INTEGER_32
			l_result_bit1: INTEGER_32
			l_alimbs: CE_ARRAY [NATURAL_32]
			l_az: CE_ARRAY [PD_MPZ_STRUCT]
			l_tmp_2: INTEGER_32
			l_a_ptr: CE_POINTER [NATURAL_32]
			l_a_size: INTEGER_32
			l_b: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			create {CE_NATURAL_32_ARRAY} l_alimbs.make (<<2>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_az.make (<<1>>)

			l_a := a_a
			if a_b.item.mp_size >= 0 then
				l_b_abs_size := a_b.item.mp_size
			else
				l_b_abs_size := (-a_b.item.mp_size)
			end
			if l_b_abs_size = 0 then
				Result := (l_a = {NATURAL_32} 1).to_integer
				l_return := True
			end
			if not l_return and then (l_a > {NATURAL_32} 4_294_967_295) then
				l_az[0].mp_alloc := (({PLATFORM}.Natural_32_bytes.to_natural_32 * (2).to_natural_32) // {PLATFORM}.Natural_32_bytes.to_natural_32).to_integer_32
				l_az[0].mp_d := l_alimbs;
				(create {P_SET_UI_STATIC}).gmpz_set_ui (l_az, l_a)
				Result := ((create {P_JACOBI_STATIC}).gmpz_jacobi (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_az), a_b))
				l_return := True
			end
			if not l_return then
				l_b_ptr := a_b.item.mp_d
				l_b_low := l_b_ptr[0]
				l_result_bit1 := 0
				if not ((l_b_low).bit_and ({NATURAL_32} 1)).to_boolean then
					if not ((l_a).bit_and ({NATURAL_32} 1)).to_boolean then
						Result := 0
						l_return := True
					end
					if not l_return then
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								if not (builtin_expect ((l_b_low = {NATURAL_32} 0).to_integer, 0)).to_boolean then
									l_break := True
								end
								if not (l_return or l_break) then
									l_b_abs_size := l_b_abs_size - 1
									l_b_ptr := l_b_ptr + 1
									l_b_low := l_b_ptr.item
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						if not ((l_b_low).bit_and ({NATURAL_32} 1)).to_boolean then
							if (builtin_expect ((l_b_low = ({NATURAL_32} 1).bit_shift_left (31)).to_integer, 0)).to_boolean then
								if l_b_abs_size = 1 then
									l_result_bit1 := ((((l_a).bit_shift_right (1))).bit_xor (l_a)).to_integer_32
									Result := (1 - ((l_result_bit1).bit_and (2)))
									l_return := True
								end
								if not l_return then
									l_b_low := ((l_b_ptr[1]).bit_shift_left (1))
								end
							else
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									l_twos := builtin_ctzl (l_b_low)
									l_break := True
								end
								l_break := False
								l_b_low := (l_b_low).bit_shift_right (l_twos)
							end
						end
					end
				else
					if l_a = {NATURAL_32} 0 then
						if l_b_abs_size = 1 then
							if l_b_low = {NATURAL_32} 1 then
								l_tmp_2 := 1
							else
								l_tmp_2 := 0
							end
						else
							l_tmp_2 := 0
						end
						Result := l_tmp_2
						l_return := True
					end
					if not l_return and then (not ((l_a).bit_and ({NATURAL_32} 1)).to_boolean) then
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_twos := builtin_ctzl (l_a)
							l_break := True
						end
						l_break := False
						l_a := (l_a).bit_shift_right (l_twos)
						l_result_bit1 := (((l_twos).bit_shift_left (1))).bit_and (((((l_b_low).bit_shift_right (1))).bit_xor (l_b_low)).to_integer_32)
					end
				end
			end
			if not l_return and then (l_a = {NATURAL_32} 1) then
				Result := (1 - ((l_result_bit1).bit_and (2)))
				l_return := True
			end
			if not l_return then
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_a_ptr := l_b_ptr
					l_a_size := l_b_abs_size.to_integer_32
					l_b := l_a
					if 22 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
						if l_a_size >= 22 then
							l_b_rem := (create {P_GMP_STATIC}).gmpn_mod_1 (l_a_ptr, l_a_size, l_b)
						else
							l_result_bit1 := (l_result_bit1).bit_xor (l_b.to_integer_32)
							l_b_rem := (create {P_GMP_IMPL_STATIC}).gmpn_modexact_1_odd (l_a_ptr, l_a_size, l_b)
						end
					else
						l_result_bit1 := (l_result_bit1).bit_xor (l_b.to_integer_32)
						l_b_rem := (create {P_GMP_IMPL_STATIC}).gmpn_modexact_1_odd (l_a_ptr, l_a_size, l_b)
					end
					l_break := True
				end
				l_break := False
				l_result_bit1 := (l_result_bit1).bit_xor (((l_a).bit_and (l_b_low)).to_integer_32)
				Result := ((create {P_GMP_IMPL_STATIC}).gmpn_jacobi_base (l_b_rem, l_a, l_result_bit1))
			end
		end

end
