class
	P_KRONZU_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_kronecker_ui (a_a: CE_POINTER [PD_MPZ_STRUCT]; a_b: NATURAL_32): INTEGER_32
		local
			l_b: NATURAL_32
			l_a_ptr: CE_POINTER [NATURAL_32]
			l_a_size: INTEGER_32
			l_a_rem: NATURAL_32
			l_result_bit1: INTEGER_32
			l_blimbs: CE_ARRAY [NATURAL_32]
			l_bz: CE_ARRAY [PD_MPZ_STRUCT]
			l_a_low: NATURAL_32
			l_twos: INTEGER_32
			l_tmp_0: INTEGER_32
			l_a_ptr2: CE_POINTER [NATURAL_32]
			l_a_size2: INTEGER_32
			l_b2: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_32_POINTER} l_a_ptr.make
			create {CE_NATURAL_32_ARRAY} l_blimbs.make (<<2>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_bz.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_b := a_b
					l_a_size := (a_a.item.mp_size).to_integer_32
					if l_a_size = 0 then
						Result := (l_b = {NATURAL_32} 1).to_integer
						l_return := True
					end
					if not l_return and then (l_b > {NATURAL_32} 4_294_967_295) then
						l_bz[0].mp_alloc := (({PLATFORM}.Natural_32_bytes.to_natural_32 * (2).to_natural_32) // {PLATFORM}.Natural_32_bytes.to_natural_32).to_integer_32
						l_bz[0].mp_d := l_blimbs;
						(create {P_SET_UI_STATIC}).gmpz_set_ui (l_bz, l_b)
						Result := ((create {P_JACOBI_STATIC}).gmpz_jacobi (a_a, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_bz)))
						l_return := True
					end
					if l_return then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						l_a_ptr := a_a.item.mp_d
						if ((l_b).bit_and ({NATURAL_32} 1)) = {NATURAL_32} 0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_result_bit1 := ((((l_a_size < 0).to_integer).bit_shift_left (1))).bit_and (l_b.to_integer_32)
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 4 then -- else:
						l_a_low := l_a_ptr[0]
						if l_b /= {NATURAL_32} 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 5 then -- if:
						if l_a_size /= 1 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 8 then -- else:
						if l_a_size /= -1 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if: | _L:
						if l_a_low = {NATURAL_32} 1 then
							l_tmp_0 := 1
						else
							l_tmp_0 := 0
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						l_tmp_0 := 0
				when 12 then -- if done
						Result := l_tmp_0
						l_return := True
				when 13 then -- if done
						if not l_return and then (not ((l_a_low).bit_and ({NATURAL_32} 1)).to_boolean) then
							Result := 0
							l_return := True
						end
						if not l_return then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_twos := builtin_ctzl (l_b)
								l_break := True
							end
							l_break := False
							l_b := (l_b).bit_shift_right (l_twos)
							l_result_bit1 := (((((l_twos).bit_shift_left (1))).bit_and (((((l_a_low).bit_shift_right (1))).bit_xor (l_a_low)).to_integer_32))).bit_xor ((((((l_a_size < 0).to_integer).bit_shift_left (1))).bit_and (l_b.to_integer_32)))
						end
				when 14 then -- if done | if done
					if not l_return and then (l_b = {NATURAL_32} 1) then
						Result := (1 - ((l_result_bit1).bit_and (2)))
						l_return := True
					end
					if not l_return then
						if l_a_size >= 0 then
							l_a_size := l_a_size
						else
							l_a_size := -l_a_size
						end
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_a_ptr2 := l_a_ptr
							l_a_size2 := l_a_size
							l_b2 := l_b
							if 22 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
								if l_a_size2 >= 22 then
									l_a_rem := (create {P_GMP_STATIC}).gmpn_mod_1 (l_a_ptr2, l_a_size2, l_b2)
								else
									l_result_bit1 := (l_result_bit1).bit_xor (l_b2.to_integer_32)
									l_a_rem := (create {P_GMP_IMPL_STATIC}).gmpn_modexact_1_odd (l_a_ptr2, l_a_size2, l_b2)
								end
							else
								l_result_bit1 := (l_result_bit1).bit_xor (l_b2.to_integer_32)
								l_a_rem := (create {P_GMP_IMPL_STATIC}).gmpn_modexact_1_odd (l_a_ptr2, l_a_size2, l_b2)
							end
							l_break := True
						end
						l_break := False
						Result := ((create {P_GMP_IMPL_STATIC}).gmpn_jacobi_base (l_a_rem, l_b, l_result_bit1))
					end
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
