class
	P_OUT_RAW_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC
	S_STDIO_STATIC
	LIBMPZ_ASSEMBLER

feature {ANY} -- public routines

	gmpz_out_raw (a_fp: CE_POINTER [SD_IO_FILE]; a_x: CE_POINTER [PD_MPZ_STRUCT]): NATURAL_32
		local
			l_fp: CE_POINTER [SD_IO_FILE]
			l_xsize: INTEGER_32
			l_abs_xsize: INTEGER_32
			l_bytes: INTEGER_32
			l_i: INTEGER_32
			l_xp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [INTEGER_8]
			l_bp: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_xlimb: CE_ARRAY [NATURAL_32]
			l_zeros: INTEGER_32
			l_tsize: NATURAL_32
			l_ssize: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_bp.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_xlimb.make (<<1>>)

			l_fp := a_fp
			l_xsize := (a_x.item.mp_size).to_integer_32
			if l_xsize >= 0 then
				l_abs_xsize := l_xsize
			else
				l_abs_xsize := -l_xsize
			end
			l_bytes := (l_abs_xsize * 32 + 7) // 8
			l_tsize := ({NATURAL_32} 4 + l_bytes.to_natural_32).to_natural_32
			l_tp := create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_GMP_IMPL_STATIC}).gmp_allocate_func.pointer_item ([l_tsize * {PLATFORM}.Integer_8_bytes.to_natural_32]))))
			l_bp.item := l_tp + ({NATURAL_32} 4).to_integer_32
			if l_bytes /= 0 then
				l_bp.item := l_bp.item + l_bytes
				l_xp := a_x.item.mp_d
				l_i := l_abs_xsize
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_bp.item := l_bp.item - (4)
					l_xlimb.item := l_xp.item
					from
					until
						(l_break)
					loop
						l_break := False
						asm21 (l_bp, l_xlimb)
						l_break := True
					end
					l_break := False
					l_xp := l_xp + 1
					l_i := l_i - 1
					if not (l_i > 0) then
						l_break := True
					end
				end
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_zeros := builtin_clzl (l_xlimb.item)
					l_break := True
				end
				l_break := False
				l_zeros := l_zeros // (8)
				l_bp.item := l_bp.item + l_zeros
				l_bytes := l_bytes - l_zeros.to_integer_32
			end
			l_ssize := (4 + l_bytes).to_natural_32
			if l_xsize >= 0 then
				l_bytes := l_bytes
			else
				l_bytes := -l_bytes
			end
			from
			until
				(l_break)
			loop
				l_break := False
				if not ({PLATFORM}.Integer_32_bytes.to_natural_32 >= {NATURAL_32} 4) then
					(create {P_GMP_IMPL_STATIC}).gmp_assert_fail (ce_string ("out_raw.c"), 147, ce_string ("sizeof (bytes) >= 4"))
				end
				l_break := True
			end
			l_break := False
			l_bp.item[-4] := ((l_bytes).bit_shift_right (24)).to_integer_8
			l_bp.item[-3] := ((l_bytes).bit_shift_right (16)).to_integer_8
			l_bp.item[-2] := ((l_bytes).bit_shift_right (8)).to_integer_8
			l_bp.item[-1] := l_bytes.to_integer_8
			l_bp.item := l_bp.item - (4)
			if l_fp.is_void then
				l_fp := ce_output_file_pointer
			end
			if (fwrite (create {CE_VOID_POINTER}.make_cast (l_bp.item), l_ssize, (1).to_natural_32, l_fp)) /= {NATURAL_32} 1 then
				l_ssize := (0).to_natural_32
			end
			(create {P_GMP_IMPL_STATIC}).gmp_free_func.call ([create {CE_VOID_POINTER}.make_cast (l_tp), l_tsize])
			Result := l_ssize
		end

end
