class
	P_POWM_SEC_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_powm_sec (a_r, a_b, a_e, a_m: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_n: INTEGER_32
			l_rp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_bp: CE_POINTER [NATURAL_32]
			l_ep: CE_POINTER [NATURAL_32]
			l_mp: CE_POINTER [NATURAL_32]
			l_rn: INTEGER_32
			l_bn: INTEGER_32
			l_es: INTEGER_32
			l_en: INTEGER_32
			l_tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp: INTEGER_32
			l_tmp_7: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l_tmp_marker.make (<<1>>)

			if a_m.item.mp_size >= 0 then
				l_n := (a_m.item.mp_size).to_integer_32
			else
				l_n := (-a_m.item.mp_size).to_integer_32
			end
			if l_n = 0 then
				(create {P_GMP_IMPL_STATIC}).gmp_divide_by_zero
			end
			l_mp := a_m.item.mp_d
			if l_mp[0] \\ {NATURAL_32} 2 = {NATURAL_32} 0 then
				(create {P_GMP_IMPL_STATIC}).gmp_divide_by_zero
			end
			l_es := (a_e.item.mp_size).to_integer_32
			if (builtin_expect ((l_es <= 0).to_integer, 0)).to_boolean then
				if l_es = 0 then
					if l_n /= 1 then
						l_tmp := 1
					elseif l_mp[0] /= {NATURAL_32} 1 then
						l_tmp := 1
					else
						l_tmp := 0
					end
					a_r.item.mp_size := l_tmp
					a_r.item.mp_d[0] := (1).to_natural_32
					l_return := True
				end
				if not l_return then
					(create {P_GMP_IMPL_STATIC}).gmp_divide_by_zero
				end
			end
			if not l_return then
				l_en := l_es
				if a_b.item.mp_size >= 0 then
					l_bn := (a_b.item.mp_size).to_integer_32
				else
					l_bn := (-a_b.item.mp_size).to_integer_32
				end
				l_tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				if (builtin_expect (((l_n + ((create {P_GMP_IMPL_STATIC}).gmpn_powm_sec_itch (l_bn, l_en, l_n))).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
					l_tmp_7 := (l_aaf.new (((l_n + ((create {P_GMP_IMPL_STATIC}).gmpn_powm_sec_itch (l_bn, l_en, l_n))).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp_7 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, ((l_n + ((create {P_GMP_IMPL_STATIC}).gmpn_powm_sec_itch (l_bn, l_en, l_n))).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				end
				l_tp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_7)
				l_rp := l_tp
				l_tp := l_tp + l_n
				l_bp := a_b.item.mp_d
				l_ep := a_e.item.mp_d;
				(create {P_GMP_IMPL_STATIC}).gmpn_powm_sec (l_rp, l_bp, l_bn, l_ep, l_en, l_mp, l_n, l_tp)
				l_rn := l_n
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						not (not (l_break) and then (l_rn > 0))
					loop
						l_break := False
						if l_rp[(l_rn - 1)] /= {NATURAL_32} 0 then
							l_break := True
						end
						if not (l_break) then
							l_rn := l_rn - 1
						end
					end
					l_break := False
					l_break := True
				end
				l_break := False
				if ((l_ep[0]).bit_and ({NATURAL_32} 1)).to_boolean then
					if a_b.item.mp_size < 0 then
						if l_rn /= 0 then
							(create {P_GMP_STATIC}).gmpn_sub (l_rp, a_m.item.mp_d, l_n, l_rp, l_rn).do_nothing
							l_rn := l_n
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									not (not (l_break) and then (l_rn > 0))
								loop
									l_break := False
									if l_rp[(l_rn - 1)] /= {NATURAL_32} 0 then
										l_break := True
									end
									if not (l_return or l_break) then
										l_rn := l_rn - 1
									end
								end
								l_break := False
								l_break := True
							end
							l_break := False
						end
					end
				end
				if (builtin_expect ((l_rn > (a_r.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
					(create {P_REALLOC_STATIC}).gmpz_realloc (a_r, l_rn).do_nothing
				end
				a_r.item.mp_size := l_rn.to_integer_32
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_GMP_STATIC}).gmpn_copyi (a_r.item.mp_d, l_rp, l_rn)
						l_break := True
					end
					l_break := False
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					if (builtin_expect ((not (l_tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						(create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_free (l_tmp_marker.item)
					end
					l_break := True
				end
				l_break := False
			end
		end

end
