class
	P_TDIV_Q_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_tdiv_q (a_quot, a_num, a_den: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_ql: INTEGER_32
			l_ns: INTEGER_32
			l_ds: INTEGER_32
			l_nl: INTEGER_32
			l_dl: INTEGER_32
			l_np: CE_POINTER [NATURAL_32]
			l_dp: CE_POINTER [NATURAL_32]
			l_qp: CE_POINTER [NATURAL_32]
			l_tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tp: CE_POINTER [NATURAL_32]
			l_tmp_3: CE_POINTER [ANY]
			l_tp_0: CE_POINTER [NATURAL_32]
			l_tmp_8: CE_POINTER [ANY]
			l_tp_1: CE_POINTER [NATURAL_32]
			l_tmp_13: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l_tmp_marker.make (<<1>>)

			l_ns := (a_num.item.mp_size).to_integer_32
			l_ds := (a_den.item.mp_size).to_integer_32
			if l_ns >= 0 then
				l_nl := l_ns
			else
				l_nl := -l_ns
			end
			if l_ds >= 0 then
				l_dl := l_ds
			else
				l_dl := -l_ds
			end
			l_ql := (l_nl - l_dl) + 1
			if l_dl = 0 then
				(create {P_GMP_IMPL_STATIC}).gmp_divide_by_zero
			end
			if l_ql <= 0 then
				a_quot.item.mp_size := 0
				l_return := True
			end
			if not l_return then
				if (builtin_expect ((l_ql > (a_quot.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
					(create {P_REALLOC_STATIC}).gmpz_realloc (a_quot, l_ql).do_nothing
				end
				l_tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				l_qp := a_quot.item.mp_d
				l_np := a_num.item.mp_d
				l_dp := a_den.item.mp_d
				if l_dp.is_equal (l_qp) then
					if (builtin_expect ((l_dl.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp_3 := (l_aaf.new ((l_dl.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp_3 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, (l_dl.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l_tp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_3)
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_tp, l_dp, l_dl)
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
					l_dp := l_tp
				end
				if l_np.is_equal (l_qp) then
					if (builtin_expect (((l_nl + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp_8 := (l_aaf.new (((l_nl + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp_8 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, ((l_nl + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l_tp_0 := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_8)
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_tp_0, l_np, l_nl)
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False;
					(create {P_GMP_IMPL_STATIC}).gmpn_div_q (l_qp, l_tp_0, l_nl, l_dp, l_dl, l_tp_0)
				else
					if (builtin_expect (((l_nl + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp_13 := (l_aaf.new (((l_nl + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp_13 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, ((l_nl + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l_tp_1 := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_13);
					(create {P_GMP_IMPL_STATIC}).gmpn_div_q (l_qp, l_np, l_nl, l_dp, l_dl, l_tp_1)
				end
				l_ql := l_ql - (l_qp[(l_ql - 1)] = {NATURAL_32} 0).to_integer
				if ((l_ns).bit_xor (l_ds)) >= 0 then
					a_quot.item.mp_size := l_ql.to_integer_32
				else
					a_quot.item.mp_size := (-l_ql).to_integer_32
				end
				from
				until
					(l_break)
				loop
					l_break := False
					if (builtin_expect ((not (l_tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						(create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_free (l_tmp_marker.item)
					end
					l_break := True
				end
				l_break := False
			end
		end

end
