class
	PD_GMP_RANDSTATE_STRUCT

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			make_initialized,
			structure_size,
			offset_of,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_mp_seed: CE_ARRAY [PD_MPZ_STRUCT]
				a_mp_alg: NATURAL_32
				a_mp_algdata: PD_MP_ALGDATA
			])
		require else
			a_data /= Void
		do
			make
			mp_seed.c_pointer.memory_copy (a_data.a_mp_seed.c_pointer, a_data.a_mp_seed.total_count * a_data.a_mp_seed.element_size)
			Current.mp_alg := a_data.a_mp_alg
			mp_algdata.c_pointer.memory_copy (a_data.a_mp_algdata.c_pointer, a_data.a_mp_algdata.structure_size)
		end

feature {ANY} -- fields

	mp_seed: CE_ARRAY [PD_MPZ_STRUCT]
		once ("OBJECT")
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} Result.make_shared (c__mp_seed (internal_c_pointer), <<1>>)
		end

	mp_alg: NATURAL_32 assign set_mp_alg
		do
			Result := c__mp_alg (internal_c_pointer)
		end

	mp_algdata: PD_MP_ALGDATA
		once ("OBJECT")
			create Result.make_shared (c__mp_algdata (internal_c_pointer))
		end

feature {ANY} -- field setters

	set_mp_alg (a_mp_alg: NATURAL_32)
		do
			c__set_mp_alg (internal_c_pointer, a_mp_alg)
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"libmpz.h%""
		alias
			"return sizeof(struct __anonstruct___gmp_randstate_struct_5);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"libmpz.h%""
		alias
			"return __alignof__(struct __anonstruct___gmp_randstate_struct_5);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__mp_seed (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmpz.h%""
		alias
			"return (EIF_POINTER)((struct __anonstruct___gmp_randstate_struct_5 *)$a_c_pointer)->_mp_seed;"
		end

	c__mp_alg (a_c_pointer: POINTER): NATURAL_32
		external
			"C inline use %"libmpz.h%""
		alias
			"return ((struct __anonstruct___gmp_randstate_struct_5 *)$a_c_pointer)->_mp_alg;"
		end

	c__mp_algdata (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmpz.h%""
		alias
			"return (EIF_POINTER)&((struct __anonstruct___gmp_randstate_struct_5 *)$a_c_pointer)->_mp_algdata;"
		end

	c__set_mp_alg (a_c_pointer: POINTER; a_mp_alg: NATURAL_32)
		external
			"C inline use %"libmpz.h%""
		alias
			"((struct __anonstruct___gmp_randstate_struct_5 *)$a_c_pointer)->_mp_alg = $a_mp_alg;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"libmpz.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "mp_seed") == 0) return offsetof(struct __anonstruct___gmp_randstate_struct_5, _mp_seed);
				if(strcmp($a_field_name, "mp_alg") == 0) return offsetof(struct __anonstruct___gmp_randstate_struct_5, _mp_alg);
				if(strcmp($a_field_name, "mp_algdata") == 0) return offsetof(struct __anonstruct___gmp_randstate_struct_5, _mp_algdata);
				fprintf(stderr, "struct __anonstruct___gmp_randstate_struct_5.%s not found\n", $a_field_name);
				return -1;
			]"
		end

end
